@echo off
setlocal
 
REM ***********************************************************************
REM   Author: Jason Fossen
REM  Updated: 10.Jun.2004
REM  Purpose: Windows 2000 and later services can be configured with automatic
REM           recovery options (see Recovery tab of a service in the Services
REM           applet in Administrative Tools).  This script sets those options
REM           on the local or a remote system.  The script takes an optional 
REM           single argument: the name of the local or remote system whose service 
REM           recovery settings will be modified.  If no argument is given, the 
REM           script defaults to the local machine only.  Must have SC.EXE locally.
REM    Notes: If you want to apply the recovery options only to a specific set of 
REM           services, then put those service names (NOT their display names) in a 
REM           file named recoveryservices.txt in the same folder as this script. 
REM           One service name per line. Run "sc.exe query type= service state= all" 
REM           to see all your service names. Otherwise, recovery options will be 
REM           set on all local services whose recovery options can be set. If 
REM           you specify a service that doesn't exist, the script will continue.
REM           Manually stopping or pausing a service does not trigger actions.
REM ***********************************************************************

REM Edit the number of seconds before count of failures is reset.
REM 
set sec=259200

REM Edit the double-quoted command you want executed IF you have a command executed,
REM but it's OK to set this even if you do not have a command run at fail-time.
REM Make sure you set NTFS permissions on any script you have run!  Consider using
REM the WSH 5.6 feature to digitally sign any VBScript or JScript scripts.
REM 
set sccommand="wscript.exe %SystemRoot%\System32\notify_service_failure.vbs /fail=%%1%%"

REM Edit the three actions you want performed, where 'action' can be one of: 
REM run, restart, or reboot. The action is followed by a forwardslash and the number 
REM of milliseconds before action is executed.  No spaces between items.
REM 
set actions=restart/120000/restart/120000/run/120000

REM ***********************************************************************




if "%1"=="" (set computer=%computername%) else (set computer=%1) 
set command=sc.exe \\%computer% failure %%i reset= %sec% actions= %actions% command= %sccommand% 
set servicelist=recoveryservices.txt
if exist recoveryservices.txt (goto run) else (goto uselocalservices)

:uselocalservices
set tempfile=%temp%\am34ku9q42bvvvvvSafeToDelete.txt 
set servicelist=%temp%\qwn37puy323vvvvvvSafeToDelete.txt
sc.exe query type= service state= all | findstr.exe "SERVICE_NAME" > %tempfile%
for /f "tokens=2 delims=:" %%i in (%tempfile%) do @echo %%i >> %servicelist%
del %tempfile% 
goto run

:run
@echo on
for /f %%i in (%servicelist%) do %command%
@echo off
if not %servicelist%==recoveryservices.txt del %servicelist%
endlocal 




