@ECHO OFF
REM *********************************************************
REM     Name: SNAPSHOT.BAT 
REM  Version: 1.0
REM     Date: 14.Nov.2002
REM   Author: Jason Fossen (www.ISAscripts.org)
REM  Purpose: Demonstrates a few tools for Windows auditing.
REM    Usage: Run batch file and redirect output (snapshot.bat > file.txt)
REM    Notes: At the bottom is a list of the other scripts/tools
REM           this script calls and their sources.  This script
REM           works on Windows 2000/XP/2003, but not Windows 9x/NT.
REM           There are a number of redundant commands below which
REM           exist for demonstration purposes only;  edit out the
REM           commands you don't need/want.  The output file will
REM           be 25 to 35 MB in size.  You should also edit the
REM           folder and drive paths in the commands below to suit
REM           your needs (most default to just %SYSTEMDRIVE%).
REM           WMIC.EXE and DRIVERQUERY.EXE cannot run on Windows 2000.
REM    Legal: Public domain.  No rights reserved.  Script provided
REM           "AS IS" with no warranties or guarantees of any kind.
REM *********************************************************


ECHO Computer: %COMPUTERNAME%  
ECHO Date: %DATE%  
ECHO Time: %TIME%  
ECHO Batchfile: %CD%\%0  
ECHO User: %USERNAME%@%USERDOMAIN%
ECHO.
ECHO.


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Operating System Version]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ver 
cscript.exe listos.vbs


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Users, Groups, And Memberships]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
addusers.exe /s:; /d %TEMP%\adduserstempfile.txt 1>nul
type %TEMP%\adduserstempfile.txt
del %TEMP%\adduserstempfile.txt 1>nul


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Password And Lockout Policies]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
net.exe accounts


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Local Audit Policy]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
auditpol.exe


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Shared Folders And Their Permissions]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
srvcheck.exe \\%computername%
net.exe share


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Processes]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
wmic.exe PROCESS list full
pulist.exe
cscript.exe ps.vbs


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Drivers]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
wmic.exe SYSDRIVER list full
drivers.exe
cscript.exe device.vbs
driverquery.exe /v


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Services]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
net.exe start
sc.exe queryex


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Networking Configuration]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ipconfig /all
netstat -an
route print
cscript.exe protocolbinding.vbs
netdiag.exe /v
nbtstat -n


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [IPSec Configuration]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
netdiag.exe /test:ipsec /debug


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Environmental Variables]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
set 


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Dump Registry Keys]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
REM reg.exe HKLM %COMPUTERNAME%.reg
regdmp.exe HKEY_LOCAL_MACHINE


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Byte And File Count For Folders]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
diruse.exe "C:\"
diruse.exe /S "%SYSTEMROOT%"
diruse.exe /S "%PROGRAMFILES%"


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Hidden Files With Last-Modified Dates]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
dir %SYSTEMDRIVE% /A:H /S /ON /T:W /N


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Non-Hidden Files With Last-Modified Dates]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
dir %SYSTEMDRIVE% /A:-D /S /ON /T:W /N


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [All Files With Version And Attributes Data]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
filever.exe %SYSTEMDRIVE% /s /b /v


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [NTFS Permissions]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
showacls.exe /s %SYSTEMDRIVE%


ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
ECHO [Dump IIS 5.x Configuration]
ECHO ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
cscript.exe adsutil.vbs ENUM_ALL /W3SVC
REM cscript.exe metaback.vbs %COMPUTERNAME%_CopyOfMetabase
REM copy /v /y %SYSTEMROOT%\System32\inetsrv\MetaBack\%COMPUTERNAME%_CopyOfMetabase.MD0 . 



REM *********************************************************
REM   Perform any post-snapshot cleanup, compression, 
REM   copying, etc..  Don't forget to nul-ify any output.
REM *********************************************************
del NetDiag.log 1>nul 2>nul
logevent.exe -s I -r "Custom Audit" -e 55555 "Audit script %0 was run on %COMPUTERNAME% by %USERNAME%@%USERDOMAIN% on %DATE% at %TIME% (Errorlevel = %ERRORLEVEL%)." 1>nul 2>nul



REM *********************************************************
REM   Tools Required And Their Sources
REM *********************************************************
REM     ADDUSERS.EXE        Windows 2000 Server Resource Kit.
REM     AUDITPOL.EXE        Windows 2000 Server Resource Kit.
REM     DEVICE.VBS          Windows 2000 Server Resource Kit.
REM     DRIVERS.EXE         Windows 2000 Server Resource Kit.
REM     LISTOS.VBS          Windows 2000 Server Resource Kit.
REM     LOGEVENT.EXE        Windows 2000 Server Resource Kit.
REM     PROTOCOLBINDING.VBS Windows 2000 Server Resource Kit.
REM     PS.VBS              Windows 2000 Server Resource Kit.
REM     PULIST.EXE          Windows 2000 Server Resource Kit.
REM     REG.EXE             Windows 2000 Server Resource Kit.
REM     SC.EXE              Windows 2000 Server Resource Kit
REM     SHOWACLS.EXE        Windows 2000 Server Resource Kit.
REM     SRVCHECK.EXE        Windows 2000 Server Resource Kit.
REM     FILEVER.EXE         Windows 2000 Support Tools.
REM     NETDIAG.EXE         Windows 2000 Support Tools.
REM     ADSUTIL.VBS         Built into Windows 2000/XP/2003.  Look in \Inetpub\AdminScripts\ folder.
REM     METABACK.VBS        Built into Windows 2000/XP/2003.  Look in \Inetpub\IISSamples\Sdk\Admin\ folder.
REM     DRIVERQUERY.EXE     Built into Windows XP/2003, can't run on Windows 2000.
REM     WMIC.EXE            Built into Windows XP/2003, can't run on Windows 2000.
REM     CSCRIPT.EXE         Built-in script interpreter (don't need to install).

REM *********************************************************
