'*******************************************************************************
' Script Name: WMI_Sample_GPO_Filters.vbs
'     Version: 1.0
'      Author: Jason Fossen 
'Last Updated: 19.Oct.2003
'     Purpose: This is not an executable script.  The following are examples
'              of WMI Filters for XP/2003 Group Policy Objects.  Don't forget
'              that Windows 2000 ignores WMI Filters.  
'       Legal: Public Domain.  Modify and redistribute freely.  No rights reserved.
'              Script is provided "AS IS" without warranties or guarantees of any kind.
'*******************************************************************************
 
'Applies if Windows Server 2003 Enterprise is the operating system.
Root\cimv2; SELECT * FROM Win32_OperatingSystem WHERE Caption = "Microsoft(R) Windows(R) Server 2003, Enterprise Edition"

'Applies if the system is a Dell Latitude CPxJ 650MHz
Root\cimv2; SELECT * FROM Win32_ComputerSystem WHERE Manufacturer = "Dell Computer Corporation" AND Model = "Latitude CPx J650GT" 
   
'Applies if ADMINPAK.MSI has been installed.
Root\cimv2; SELECT * FROM Win32_Product WHERE name = "ADMINPAK"
  
'Applies if there is at least 500MB (524,288,000 bytes) available on any drive. 
Root\cimv2; SELECT * FROM Win32_LogicalDisk WHERE FreeSpace > 524288000 AND Description = "Local Fixed Disk"
  
'Applies if located in the eastern time zone, i.e., five hours behind UTC "Zulu" time.
Root\cimv2; SELECT * FROM win32_timezone WHERE bias =-300

'Applies if patch KB819696 or KB828026 has been applied.
Root\cimv2; SELECT * FROM Win32_QuickFixEngineering WHERE HotFixID = "KB819696" OR HotFixID = "KB828026"




